import { _decorator, Component, Node } from 'cc';
import { PetIcon } from './PetIcon';
const { ccclass, property } = _decorator;

@ccclass('PetIconSelect')
export class PetIconSelect extends Component {

    @property(PetIcon)
    petIcon:PetIcon;

    //选中节点
    @property(Node)
    select:Node;

    //不可选中节点
    @property(Node)
    noselect:Node;

    //是否被选中
    _isSelect:boolean = false;
    get isSelect(){
        return this._isSelect;
    }
    set isSelect(data:boolean){
        this._isSelect = data;
        this.onUpdateSelect();
    }

    //是否不可选中
    _isNoSelect:boolean = false;
    get isNoSelect(){
        return this._isNoSelect;
    }
    set isNoSelect(data:boolean){
        this._isNoSelect = data;
        this.onUpdateSelect();
    }

    onLoad(){
        this.onUpdateSelect();
        this.noselect.active = false;
        this.select.active = false;
    }

    
    //设置icon
    setIcon(petTbId:number){

        this.petIcon.setIcon(petTbId);
        
    }

    onUpdateSelect(){

        this.select.active = this.isSelect;
        this.noselect.active = this.isNoSelect;

    }

}


