import { _decorator, Component, Node } from 'cc';
import { JNGLayerBase } from '../../../components/JNComponent';
import { tween } from 'cc';
import { v3 } from 'cc';
import { app } from '../../../App';
import { GAction } from '../../../consts/GAction';
const { ccclass, property } = _decorator;

/**
 * 游戏匹配页面
 */
@ccclass('PVPMatchView')
export class PVPMatchView extends JNGLayerBase {

    @property(Node)
    content:Node;

    onJNLoad(data?: any): void {
        super.onJNLoad(data);
        tween(this.content)
            .repeatForever(
                tween()
                    .to(.5,{scale:v3(.8,.8,.8)})
                    .to(.5,{scale:v3(1,1,1)})
            )
            .start();

    }

    //取消匹配
    onClickCancel(){
        app.socket.Send(GAction.S_MODE_PVP_LEAVE)
    }

}


