package cn.jisol.game.actions;

import cn.jisol.game.network.client.GRefereeClient;
import cn.jisol.game.proto.GPVPMessage;
import cn.jisol.ngame.actions.core.NAction;
import cn.jisol.ngame.actions.core.NActionMethod;

import java.util.Map;
import java.util.Objects;

/**
 * 裁决员行为 处理裁决
 */
@NAction
public class GRefereeAction {

    //裁决员列表
    public static Map<String, GRefereeClient> REFEREES;

    //获取一个空闲的裁决员
    public static GRefereeClient getFreeReferee(){

        for (String key : REFEREES.keySet()) {
            if (!(REFEREES.get(key).isReferee)) {
                REFEREES.get(key).isReferee = true;
                return REFEREES.get(key);
            }
        }
        return null;

    }

    //放回一个空闲裁决员
    public static void addFreeReferee(GRefereeClient referee){
        referee.isReferee = false;
    }

    //自动回收裁决
    public static boolean autoReferee(GRefereeActionAutoInter inter){
        GRefereeClient referee = getFreeReferee();
        if (Objects.nonNull(referee)) {
            referee = inter.run(referee);
            //未使用则收回
            if(Objects.nonNull(referee)){
                addFreeReferee(referee);
                return false;
            }
            return true;
        }
        return false;
    }

    public interface GRefereeActionAutoInter{
        GRefereeClient run(GRefereeClient referee);
    }

}
