package cn.jisol.game.interceptor;

import cn.jisol.game.controller.exception.TokenException;
import cn.jisol.game.data.Cache;
import cn.jisol.game.entity.User;
import org.springframework.stereotype.Component;
import org.springframework.web.servlet.HandlerInterceptor;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.util.Objects;

/**
 * 游戏登录拦截器
 */
@Component
public class LoginInterceptor implements HandlerInterceptor {


    @Override
    public boolean preHandle(HttpServletRequest request, HttpServletResponse response, Object handler) throws Exception {
        //获取Token
        String token = request.getHeader(Cache.KEY_TOKEN);
        if(Objects.isNull(token) || Objects.isNull(Cache.TOKEN.get(token))) {
            //抛出Token异常
            throw new TokenException();
        }
        return true;
    }
}
