package cn.jisol.game.listener;

import cfg.Tables;
import cn.hutool.core.io.resource.ResourceUtil;
import cn.hutool.json.JSONUtil;
import cn.jisol.game.data.Cache;
import cn.jisol.game.data.GlobalId;
import cn.jisol.game.data.TD;
import com.google.gson.JsonParser;
import org.springframework.context.event.ContextRefreshedEvent;
import org.springframework.context.event.EventListener;
import org.springframework.stereotype.Component;

import java.io.FileReader;
import java.io.IOException;
import java.io.InputStream;
import java.util.List;

@Component
public class InitGameListener {

    @EventListener(ContextRefreshedEvent.class)
    public void onApplicationEvent(ContextRefreshedEvent event) {

        try {
            InputStream fileInputStream;
            TD.DATA = new Tables(file -> {
                System.out.println("加载配置表:"+file);
                return JsonParser.parseString(ResourceUtil.readUtf8Str("json/"+file+".json"));
            });

            //设置基础缓存信息
            //裁决员
            Cache.REFEREES = JSONUtil.toList(TD.DATA.getTbSServerInfo().get(GlobalId.SERVER_REFEREE_ID).args, String.class);

        } catch (IOException e) {
            e.printStackTrace();
        }

    }

}
